## kodi-addon-inputstream-rtmp-21.1.2-1.src.tar.gz

=== depends/common/librtmp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(librtmp)

if(CORE_SYSTEM_NAME STREQUAL osx OR CORE_SYSTEM_NAME STREQUAL ios OR CORE_SYSTEM_NAME STREQUAL darwin_embedded)
  set(SYS darwin)
else()
  set(SYS posix)
endif()

set(cflags ${CMAKE_C_FLAGS} -I${OUTPUT_DIR}/include)

include(ExternalProject)
externalproject_add(librtmp
                    SOURCE_DIR ${CMAKE_SOURCE_DIR}
                    CONFIGURE_COMMAND ""
                    BUILD_COMMAND cd <SOURCE_DIR>
                                  && make -C librtmp SHARED= prefix=${OUTPUT_DIR} INC=-I${OUTPUT_DIR}/include SYS=${SYS}
                                     XCFLAGS=${cflags} XDEF=-U_DEBUG CC=${CMAKE_C_COMPILER} AR=${CMAKE_AR} XLDFLAGS=${OUTPUT_DIR}/lib
                    INSTALL_COMMAND "")

install(CODE "execute_process(COMMAND make -C librtmp install
                                      prefix=${OUTPUT_DIR} SYS=${SYS} XCFLAGS=-fpic SHARED=
                              WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})")

=== depends/windows/librtmp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(librtmp C CXX)

add_definitions(
	-DUSE_OPENSSL
	-D_CRT_NONSTDC_NO_DEPRECATE
	-D_CRT_SECURE_NO_WARNINGS
	-D_WINSOCK_DEPRECATED_NO_WARNINGS
)

find_package(OpenSSL REQUIRED)
find_package(ZLib REQUIRED)

include_directories(
	${CMAKE_SOURCE_DIR}/librtmp
	${OPENSSL_INCLUDE_DIR}
	${ZLIB_INCLUDE_DIRS}
)

add_library(librtmp
	librtmp/amf.h
	librtmp/amf.c
	librtmp/bytes.h
	librtmp/dh.h
	librtmp/dhgroups.h
	librtmp/handshake.h
	librtmp/hashswf.c
	librtmp/http.h
	librtmp/log.h
	librtmp/log.c
	librtmp/parseurl.c
	librtmp/rtmp.h
	librtmp/rtmp.c
	librtmp/rtmp_sys.h
)
if(MSVC AND CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
  target_sources(librtmp PRIVATE
    librtmp/uwpapi.cpp
  )
  set_source_files_properties(librtmp/uwpapi.cpp PROPERTIES COMPILE_FLAGS "/TP /ZW")
endif()

target_link_libraries(librtmp ${OPENSSL_LIBRARIES} ${ZLIB_LIBRARIES} Ws2_32 winmm gdi32)

target_compile_options(librtmp PRIVATE -DEXPORT)

install(TARGETS librtmp
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

install(FILES
	librtmp/amf.h
	librtmp/http.h
	librtmp/log.h
	librtmp/rtmp.h
	DESTINATION include/librtmp
)

=== depends/windows/openssl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(openssl VERSION 1.1.1 LANGUAGES C)

find_package(StrawberryPerl REQUIRED)

include(CheckSymbolExists)
check_symbol_exists(_X86_ "Windows.h" _X86_)
check_symbol_exists(_AMD64_ "Windows.h" _AMD64_)

if(_X86_)
	message(STATUS "Win32")
	set(OPENSSL_PLATFORM VC-WIN32)
elseif(_AMD64_)
	message(STATUS "x64")
	set(OPENSSL_PLATFORM VC-WIN64A)
else()
	message(FATAL_ERROR "Unsupported target architecture")
endif()

message(STATUS "perl Configure ${OPENSSL_PLATFORM} disable-capieng enable-static-engine no-asm no-dso no-shared no-tests no-ui-console zlib --prefix=${CMAKE_INSTALL_PREFIX} --with-zlib-include=${OUTPUT_DIR}/include")
set(ENV{PATH} "${STRAWBERRYPERL_PATH};$ENV{PATH}")
execute_process(COMMAND perl Configure ${OPENSSL_PLATFORM} disable-capieng enable-static-engine no-asm no-dso no-shared no-tests no-ui-console zlib --prefix=${CMAKE_INSTALL_PREFIX} --with-zlib-include=${OUTPUT_DIR}/include WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_custom_target(openssl ALL COMMAND nmake build_generated libcrypto.lib libssl.lib WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(DIRECTORY include/openssl DESTINATION include/ FILES_MATCHING PATTERN "*.h")
install(FILES libcrypto.lib libssl.lib DESTINATION lib/)

=== depends/windowsstore/openssl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(openssl)

include(CheckSymbolExists)
check_symbol_exists(_X86_ "Windows.h" _X86_)
check_symbol_exists(_AMD64_ "Windows.h" _X64_)
check_symbol_exists(_ARM_ "Windows.h" _ARM_)
check_symbol_exists(_ARM64_ "Windows.h" _ARM64_)

if(_X86_)
  set(OPENSSL_ARCHIVE_NAME openssl-1.1.1d-win10-win32-v141-20200105)
elseif(_X64_)
  set(OPENSSL_ARCHIVE_NAME openssl-1.1.1d-win10-x64-v141-20200105)
elseif(_ARM_)
  set(OPENSSL_ARCHIVE_NAME openssl-1.1.1d-win10-arm-v141-20200105)
elseif(_ARM64_)
  set(OPENSSL_ARCHIVE_NAME openssl-1.1.1d-win10-arm64-v141-20200105)
else()
  message(FATAL_ERROR "Unsupported architecture")
endif()

message(STATUS "Downloading http://mirrors.kodi.tv/build-deps/win32/${OPENSSL_ARCHIVE_NAME}.7z")
file(DOWNLOAD http://mirrors.kodi.tv/build-deps/win32/${OPENSSL_ARCHIVE_NAME}.7z ${CMAKE_CURRENT_BINARY_DIR}/${OPENSSL_ARCHIVE_NAME}.7z SHOW_PROGRESS)
execute_process(COMMAND ${CMAKE_COMMAND} -E tar xzvf ${OPENSSL_ARCHIVE_NAME}.7z WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${OPENSSL_ARCHIVE_NAME}/ DESTINATION ${CMAKE_INSTALL_PREFIX})

=== PKGBUILD ===
# Maintainer: BlackIkeEagle <ike DOT devolder AT gmail DOT com>
# Contributor: kevku <kevku@gmx.com>

pkgname=kodi-addon-inputstream-rtmp
pkgver=21.1.2
_codename=Omega
pkgrel=1
pkgdesc="RTMP input stream add-on for Kodi"
arch=('x86_64')
url="https://github.com/xbmc/inputstream.rtmp"
license=('GPL2')
groups=('kodi-addons' 'kodi-addons-inputstream')
makedepends=('cmake' 'rtmpdump' 'p8-platform' 'kodi-dev')
options=(!lto)
source=("$pkgname-$pkgver.tar.gz::https://github.com/xbmc/inputstream.rtmp/archive/$pkgver-$_codename.tar.gz")
sha512sums=('4f5930a65132302665c07a6a0ffa693e0a20c5b3244627bd3773514907bda0a403f1ff0016af5bd61ac2ea5bf4288b169d104e09f57440c0f64e0094bd3deba6')

build() {
    cd "inputstream.rtmp-$pkgver-$_codename"
    cmake \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE=Release \
        -DBUILD_SHARED_LIBS=1 \
        -DUSE_LTO=1 \
        .
    make
}

package() {
    depends=('kodi' 'rtmpdump' 'p8-platform')
    cd "inputstream.rtmp-$pkgver-$_codename"
    make DESTDIR="$pkgdir/" install
}
